#!/bin/sh -
# 
# $Copyright
# Copyright 1993, 1994 , 1995 Intel Corporation
# INTEL CONFIDENTIAL
# The technical data and computer software contained herein are subject
# to the copyright notices; trademarks; and use and disclosure
# restrictions identified in the file located in /etc/copyright on
# this system.
# Copyright$
# 
 
#
# @OSF_COPYRIGHT@
#
#
# Mach Operating System
# Copyright (c) 1989 Carnegie-Mellon University
# All rights reserved.  The CMU software License Agreement specifies
# the terms and conditions for use and redistribution.
#
#
# HISTORY
# $Log: newvers.sh,v $
# Revision 1.12  1994/11/18  20:29:51  mtm
# Copyright additions/changes
#
# Revision 1.11  1993/07/14  17:54:32  cfj
# OSF/1 AD 1.0.4 code drop from Locus.
#
# Revision 1.1.1.3  1993/07/01  19:12:58  cfj
# Adding new code from vendor
#
# Revision 1.10  1993/05/10  23:43:22  cfj
# Make it so that the name has the proper version in it.
#
# Revision 1.9  1993/05/06  19:15:06  cfj
# ad103+tnc merged with Intel code.
#
# Revision 1.1.1.1  1993/05/03  17:27:57  cfj
# Initial 1.0.3 code drop
#
# Revision 1.1.2.1  1992/11/05  23:18:42  dleslie
# Local changes for NX through noon, November 5, 1992.
#
# Revision 2.11  93/05/16  20:59:54  loverso
# 	Add BS for echo differences btwn v7/BSD/4.1/1.0 and 1.0/1.2
# 
# Revision 2.10  92/09/17  13:42:29  rabii
# 	[1992/09/14  00:18:28  stans]
# 	pretty print version string by 1st splitting at the date field.
# 	2nd: one too many backslashes at the end of quoted string left the "\n"
# 	embedded instead of being a <CRLF>.
#
# Revision 2.9  92/05/24  14:22:48  pjg
# 	Revision 3.8  92/03/20  15:08:38  jose
# 	Added norma_mk version.
#
# Revision 2.8  92/03/09  12:02:26  durriya
# 	[Revision 3.7  92/01/15  16:54:59  jose]
# 	Added user name to server version [Simon].
# 
# Revision 2.7  91/12/18  20:17:55  roy
# 	Add space before banner.
# 
# Revision 2.6  91/12/16  15:02:26  roy
# 	91/12/11  15:12:04  condict
# 	Remove space from server build id, so that vmunix.SVRnn.CONFIG file 
# 	will be generated properly.
# 
# 	91/11/26  15:33:08  sp
# 	Upgrade to 1.0.3
# 
# 	91/09/10  12:02:45  barbou
# 	Added the required MK version number as an argument to newvers.sh.
# 
# Revision 2.5  91/10/17  13:16:54  roy
# Fix revision history comment leader.
# 
# Revision 2.4  91/10/15  12:59:44  sjs
# removed debug hack
# 
# Revision 2.3  91/10/15  09:25:41  sjs
#	 Revision 3.4  91/09/10  12:02:45  barbou
#	 Added the required MK version number as an argument to newvers.sh.
#	 
# Revision 2.2  91/08/31  13:31:10  rabii
#	Initial V2.0 Checkin
#
# Revision 3.3  91/08/28  10:54:54  barbou
# Upgrade to OSF/1.0.2. (unchanged copy from OSF/1.0.2).
# 
# Revision 1.9.5.3  91/08/27  13:12:39  klein
#	changed version_release to include patch release for uts_name struct
#	initialization
#	[91/08/27  13:09:47  klein]
#
# Revision 1.9.5.2  91/07/30  15:44:47  ezf
#	now uses $BUILD env. variable rather than version.build
#	[91/07/30  15:40:57  ezf]
#
# Revision 1.9.3.2  91/03/15  17:04:36  jeffc
# 	Fix ANSI-C violation -- unescaped newline in character constant.
# 	[91/02/27  21:27:26  jeffc]
# 
# 	Fix generation of vers.suffix file
# 	[90/11/19  13:28:22  brezak]
# 
# 	The build variant field will drop out if version.variant="?" and the
# 	release field will become the version+patch. The version will always
# 	be the base version.
# 	[90/11/12  18:27:30  brezak]
# 
# 	Make "patch" part of version.
# 	[90/11/08  18:22:32  brezak]
# 
# Revision 1.9  90/12/06  14:02:10  devrcs
# 	Changes for osc1.0 release.
# 	[90/12/01  18:25:53  gm]
# 
# Revision 1.8  90/10/07  13:23:57  devrcs
# 	Added EndLog Marker.
# 	[90/09/28  09:09:34  gm]
# 
# Revision 1.7  90/08/09  13:16:41  devrcs
# 	Protect non-ansi compilers.
# 	[90/08/03  18:48:44  tmt]
# 
# 	Add const to versions and copyright string.
# 	[90/08/03  17:42:36  tmt]
# 
# Revision 1.6  90/06/22  20:09:18  devrcs
# 	nags merge
# 	[90/06/12  21:21:47  gmf]
# 
# Revision 1.5  90/05/24  23:00:42  devrcs
# 	Change the format of the version string.
# 	[90/05/17  15:27:59  brezak]
# 
# Revision 1.4  90/05/13  18:35:19  devrcs
# 	Change format.
# 	Change version string to be more appropriate for our build
# 	environment.
# 	[90/05/04  10:26:39  brezak]
# 
# 	Added argument for version banner to replace "Mach" string.
# 	[90/05/02  19:21:04  brezak]
# 
# 	Added option to add additional banner via conf/vers.banner file
# 	[90/05/02  14:17:57  brezak]
# 
# Revision 1.3  90/04/14  00:30:56  devrcs
# 	Name that baby: "OSF/1 Mach" <- "Mach/4.3"
# 	[90/04/05  14:08:50  tmt]
# 
# Revision 1.2  90/01/02  20:04:22  gm
# 	Fixes for first snapshot.
# 
# Revision 1.1  89/10/16  19:33:07  gm
# 	Mach 2.5 and Encore 0.6 merge
# 
# Revision 6.2  89/08/28  12:24:14  boykin
# 	Modified to add Encore Copyright message and add Encore version of
# 	version string.
# 
# Revision 6.1  89/07/26  16:30:52  alan
# 	Mach Release 2.5 (preliminary) merged with Encore Multimax
# 	support and BSD parallelization changes.
# 
# Revision 2.10  89/08/10  14:41:47  jsb
# 	Added code to set CONFIG from new vers.config file.
# 	[89/08/10            gm0w]
# 
# Revision 2.9  89/08/08  15:36:31  gm0w
# 	Changed to also use CONFIG in the version string.
# 	[89/08/08            gm0w]
# 
# Revision 2.8  89/08/08  13:44:21  gm0w
# 	Changed to use config from the environment and exit when it
# 	is not defined.
# 	[89/08/08            gm0w]
# 
# Revision 2.7  89/02/25  17:41:51  gm0w
# 	Changes for cleanup.
# 
# Revision 2.6  88/10/18  03:17:50  mwyoung
# 	Removed the original form of this script that was left in comments.
# 	Removed old history.
# 	[88/10/15            mwyoung]
# 
# Revision 2.5  88/10/11  10:08:21  rpd
# 	Changed version_variant & version_patch to open arrays.
# 	Fixed the definition of CONFIG to use the last component of the
# 	working directory without cutting off at underscores.
# 	[88/10/04  06:55:37  rpd]
# 
# Revision 2.4  88/07/20  16:23:53  rpd
# 	Made version string open-sized.
# 
# Revision 0.0  86/11/15            mja
# 	Removed increment of version number which is now done by the
# 	Makefile and which depends only on changes to the source files
# 	and not the build directory.
# 	[86/11/15            mja]
# 
# $EndLog$

case `echo 'a\nb'` in
	*nb)	BS="" ;;
	*)	BS='\' ;;
esac

#
# Copyright (c) 1980, 1986 Regents of the University of California.
# All rights reserved.  The Berkeley software License Agreement
# specifies the terms and conditions for redistribution.
#
#	@(#)newvers.sh	7.1 (Berkeley) 6/5/86
#
# newvers.sh copyright major minor variant (build) patch banner
#

# Since we now have more than 9 parameters, the only way we can get the
# tenth one is with 'shift'.
#		Dave Leslie 1/28/93
if [ "$6" != "?" ]; then
        patch="$6"
fi
if [ "$4" != "?" ]; then
        variant="$4"
else
        variant=""
fi
copyright="$1"; shift
major="$1"; shift
minor="$1"; shift; shift
build="$1"; shift; shift
banner="$1"; shift 
mk="$1"; shift
norma_mk="$1"; shift
pgmname="$1"
mkidinfo -f $pgmname
relvers=`cat _cvs_id.c | sed -n -e 's/^.*"@/@/' -e 's/";$//p'`
rm -f _cvs_id.c
h=`hostname` t=`date` u=$USER
# use the BUILD env variable rather than $5 for build id (only don't - sp)
#build=${BUILD:-"b?"}
v="${major}.${minor}${patch+.${patch}}"
#bui="${variant+${variant}${build+${build}}}"
#if [ "X${variant}" = "X" ]; then
#        b=""
#else
#        b="(${bui})"
#fi
vers=`echo $relvers | awk '{print $3}'`
bui="${vers}"

if [ -r vers.config ]; then
     CONFIG=`cat vers.config`
fi

if [ -z "$h" -o -z "$t" -o -z "${CONFIG}" ]; then
    exit 1
fi
(
  echo "#ifdef __STDC__" ;
  echo "#define CONST const" ;
  echo "#else" ;
  echo "#define CONST" ;
  echo "#endif" ;
  echo "CONST int  version_need_mk    = ${mk};" ;
  echo "CONST int  version_need_norma_mk = ${norma_mk};" ;
  echo "CONST int  version_major      = ${major};" ;
  echo "CONST int  version_minor      = ${minor};" ;
  echo "CONST char version_version[32]  = \"${vers}\";" ;
  echo "CONST char version_ident[128]  = \"${relvers}\";" ;
  echo "CONST char version_release[32]  = \"${v}\";" ;
  echo "CONST char version[] = \"Paragon OSF/1 Release ${v} ${banner} ${vers}; ${t};${BS}\\n    ${CONFIG}${BS}\\n\";" ;
  echo "CONST char copyright[] = \"\\" ;
  sed <$copyright -e '/^#/d' -e 's;[ 	]*$;;' -e '/^$/d' -e 's;$;\\n\\;' ;
  echo "\";";
) > vers.c
if [ -s vers.suffix -o ! -f vers.suffix ]; then
    echo ".${bui}.${CONFIG}" >vers.suffix
fi
exit 0

